I have a fork of OpenCV on my GitHub profile which implements an ImageDecoder for GDAL. | have had
code for a long time which will use GDAL to load a raster into an OpenCV Mat. | took that and implemented
what | believe are the required components in order to load rasters natively using OpenCV imread. You can
clone the repo at https://github.com/marvins/opencv . Let me know if this is something you are interested in
including and | can implement whatever is required to get it added.

I am avoiding a Pull Request as this is not tied to a specific bug or issue. Also, this adds a rather large
dependency to OpenCV in that GDAL includes a lot of dependencies of its own. It will most certainly cause
issues if run on a build farm. To install GDAL on Ubuntu, install the "libgdal-dev" package. On Fedora, install
the "gdal-devel" package. | am a little naive with building OpenCV on Windows, so | am not sure if it would
work.

In the master branch of my OpenCYV fork, | have added the CMake flags to find and include GDAL. | also
created a functional example in the Sphinx documentation under the HighGui tutorials.

| have tested the driver with the following formats...

Digital Elevation Models
*DTED
*SRTM

Rasters

*NITF (2.0/2.1)
* GeoTiff
*JPEG

* Tiff

*J2K

If there is interest in supporting GDAL, | would be more than happy to dig into the ImageEncoder driver. In
addition, GDAL can load the image Metadata as well as do coordinate conversions. Also, if there are any
bugs, improvements, or fixes in my code that you would like me to make, just let me know.

Thanks,
Marvin

Changed or Added Files

* CMakelLists.txt

* cmake/OpenCVFindLibsGrfmt.cmake

* cmake/templates/cvconfig.h.in

* doc/tutorials/definitions/tocDefinitions.rst

* doc/tutorials/highgui/raster-gdal/images/flood-zone.jpg
* doc/tutorials/highgui/raster-gdal/images/heat-map.jpg
* doc/tutorials/highgui/raster-gdal/images/output.jpg

* doc/tutorials/highgui/raster-gdal/raster_io_gdal.rst

* doc/tutorials/highgui/table_of _content_highgui/images/gdal-io.jpg
* doc/tutorials/highgui/table_of content_highgui/table_of _content_highgui.rst
* modules/highgui/CMakelLists.txt

* modules/highgui/include/opencv2/highgui.hpp

* modules/highgui/src/grfmt_gdal.cpp

* modules/highgui/src/grfmt_gdal.hpp

* modules/highgui/src/grfmts.hpp

* modules/highgui/src/loadsave.cpp

* samples/cpp/tutorial_code/HighGUI/GDAL_10/gdal-image.cpp

History

2014-05-29 09:44 am - Dmitry Retinskiy
- Assignee set to Marvin Smith

- Status changed from New to Open

Hi Marvin,
thanks for the work you have done! This is always appreciated.

Pull request is nevertheless a right way to proceed with the review.
Reviewers could advice how to proceed with the problems you mentioned.

2014-05-29 06:10 pm - Marvin Smith
Submitted the Pull Request. Thanks. Let me know what the desirability of this module is.

2015-05-25 02:52 pm - Vadim Pisarevsky

- Status changed from Open to Done

thanks! the PR has been merged in

2025-03-14
